package com.autocareai.mvvmdemo.demo.list

import androidx.lifecycle.LifecycleOwner
import com.autocareai.lib.lifecycle.extension.post
import com.autocareai.lib.lifecycle.livedata.SingleLiveEvent
import com.autocareai.mvvmdemo.common.view.BaseViewModel
import com.autocareai.mvvmdemo.demo.api.DemoApi
import com.autocareai.mvvmdemo.demo.enity.PopularWebsitesEntity

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/28
 *     desc   : 常用网站ViewModel
 *     version: 1.0
 * </pre>
 */
class PopularWebsitesViewModel : BaseViewModel() {

    /**
     * 常用网站数据
     */
    var listDataEvent = SingleLiveEvent<ArrayList<PopularWebsitesEntity>>()
    // val popularWebsites = MutableLiveData<ArrayList<ListEntity>>()

    // TODO: 2020/6/29 事件用SingleLiveEvent，比如：toast，显示弹窗，跳转界面，UI显示用MutableLiveData。
    // TODO: 2020/6/29 事件字段命名有Event后缀，UI显示没有后缀，比如 userName，而不是 userNameEvent

    /**
     * 获取常用网站
     */
    fun loadPopularWebsitesList(owner: LifecycleOwner) {
        DemoApi.listPopularWebsites()
            .attachLifecycle(owner)
            .onSuccess {
                listDataEvent.post(it)
            }.onError { _, message ->
                shortToast(message)
            }.async()
    }
}